/*
*	bazo.c - ĝeneralaj funkcioj por bibliotekoj.
*	© 2005, A.A.Vladimirov.
*
*	Ĉi tiu verko estas libera programaro; vi povas ĝin pludistribui kaj/aŭ
*	modifi je la kondiĉoj de la GNUa Ĝenerala Publika Permesilo, eldonita de
*	«Free Software Foundation», laŭ la versio 2 de tiu Permesilo aŭ, se vi
*	preferas, ajna posta versio.
*
*	Ni distribuas ĉi tiun programon esperante ke ĝi estos utila, tamen
*	SEN IA AJN GARANTIO, i.a. sen la implica garantio pri SURMERKANTIGEBLO
*	aŭ TAŬGECO POR IU KONKRETA CELO. Pliajn detalojn vidu en la GNUa
*	Ĝenerala Publika Permesilo.
*
*	Ekzemplero de la GNUa Ĝenerala Publika Permesilo devas esti liverita al vi
*	kun ĉi tiu programo; se vi ĝin ne ricevis, turnu vin al
*	
*	Free Software Foundation, Inc.,
*	59 Temple Place, Suite 330,
*	Boston, MA 02111-1307
*	USA
*
*/

# include "refal.h"


/* ========================================================================== */


extern void ref_eraro (int);


/* ========================================================================== */


void baz_krei_linion (char *linio) {
	int i = 0, k = 0;
	unsigned long c = 0;
	LITERO *kuranta;
	
	kuranta = KKK->sekv;
	while ((kuranta != KKP) && (!ESTAS_D_STR_PARENT (kuranta))) {
		switch (kuranta->tip) {
			case MD_LIT_PARENT:
				c = 0;
				i = 0;
				break;
			
			case D_LIT_PARENT:
				i = 0;
				if ((i == 0) && (c < 128)) {
					if (k == LIN_LIM - 1) ref_eraro (5);
					linio [k] = (char) c;
					c = 0;
					k ++;
					i = 1;
				};
				if ((i == 0) && (c > 127) && (c < 2048)) {
					if (k == LIN_LIM - 1) ref_eraro (5);
					linio [k] = (char) ((c >> 6) + 192);
					c = (c << 26);
					k ++;
					i = 2;
				};
				if ((i == 0) && (c > 2047) && (c < 65536)) {
					if (k == LIN_LIM - 1) ref_eraro (5);
					linio [k] = (char) ((c >> 12) + 224);
					c = (c << 20);
					k ++;
					i = 3;
				};
				if ((i == 0) && (c > 65535) && (c < 2097152)) {
					if (k == LIN_LIM - 1) ref_eraro (5);
					linio [k] = (char) ((c >> 18) + 240);
					c = (c << 14);
					k ++;
					i = 4;
				};
				if ((i == 0) && (c > 2097151) && (c < 67108864)) {
					if (k == LIN_LIM - 1) ref_eraro (5);
					linio [k] = (char) ((c >> 24) + 248);
					c = (c << 8);
					k ++;
					i = 5;
				};
				if ((i == 0) && (c > 67108863) && (c < 2147483648u)) {
					if (k == LIN_LIM - 1) ref_eraro (5);
					linio [k] = (char) ((c >> 30) + 252);
					c = (c << 2);
					k ++;
					i = 6;
				};
				while (i != 1) {
					if (k == LIN_LIM - 1) ref_eraro (5);
					linio [k] = (char) ((c >> 26) + 128);
					c = (c << 6);
					k ++;
					i --;
				};
				break;
			
			case CIFER:
				switch (i) {
					case 0:
						c += kuranta->dat.cif;
						i ++;
						break;
					
					case 1:
						c += (kuranta->dat.cif) * 65536;
						if (c > 2147483647) ref_eraro (7);
						i ++;
						break;
					
					default:
						ref_eraro (7);
						break;
				};
				break;
			
			default:
				ref_eraro (8);
				break;
		};
		kuranta = kuranta->sekv;
		detrui_literon (kuranta->ant);
		ligi_literojn (KKK, kuranta);
	};
	linio [k] = '\0';
	return;
}


void baz_krei_bajtojn (char *linio) {
	int i = 0, k = 0;
	unsigned int c = 0;
	LITERO *kuranta;
	
	kuranta = KKK->sekv;
	while ((kuranta != KKP) && (!ESTAS_D_STR_PARENT (kuranta))) {
		switch (kuranta->tip) {
			case MD_LIT_PARENT:
				i = 0;
				break;
			
			case D_LIT_PARENT:
				if (c < 256) {
					if (k == LIN_LIM - 1) ref_eraro (5);
					linio [k] = (char) c;
					c = 0;
					k ++;
				};
				break;
			
			case CIFER:
				if (i) {
					ref_eraro (2);
				}
				else {
					c = kuranta->dat.cif;
					i ++;
				};
				break;
			
			default:
				ref_eraro (8);
				break;
		};
		kuranta = kuranta->sekv;
		detrui_literon (kuranta->ant);
		ligi_literojn (KKK, kuranta);
	};
	linio [k] = '\0';
	return;
}


unsigned long baz_preni_literon (char *linio, int *pozicio) {
	int k;
	unsigned long l;
	
	if ((linio [*pozicio]) >> 7 == 0) {
		k = *pozicio;
		(*pozicio) ++;
		return (unsigned long) (linio [k]);
	};
	if (((linio [*pozicio]) >> 6 == 2) || ((linio [*pozicio]) == 254) ||
	((linio [*pozicio]) == 255)) ref_eraro (7);
	k = 32;
	while (((linio [*pozicio]) & k) != 0) k /= 2;
	switch (k) {
		case 32:
			k = 2;
			break;
		
		case 16:
			k = 3;
			break;
		
		case 8:
			k = 4;
			break;
		
		case 4:
			k = 5;
			break;
		
		case 2:
			k = 6;
			break;
	};
	l = (unsigned long) ((linio [*pozicio]) & (255 >> k));
	k = (*pozicio) + k;
	(*pozicio) ++;
	while (k != (*pozicio)) {
		if ((linio [*pozicio]) >> 6 != 2) ref_eraro (7);
		l *= 64;
		l += (unsigned long) ((linio [*pozicio]) & 63);
	 	(*pozicio) ++;
	};
	return l;
}


unsigned long baz_preni_bajton (char *linio, int *pozicio) {
	int k;
	
	k = *pozicio;
	(*pozicio) ++;
	return (unsigned long) (linio [k]);
}

