/*
*	sistemo.c - biblioteko de sistemaj funkcioj por refalsistemo.
*	© 2005, A.A.Vladimirov.
*
*	Ĉi tiu verko estas libera programaro; vi povas ĝin pludistribui kaj/aŭ
*	modifi je la kondiĉoj de la GNUa Ĝenerala Publika Permesilo, eldonita de
*	«Free Software Foundation», laŭ la versio 2 de tiu Permesilo aŭ, se vi
*	preferas, ajna posta versio.
*
*	Ni distribuas ĉi tiun programon esperante ke ĝi estos utila, tamen
*	SEN IA AJN GARANTIO, i.a. sen la implica garantio pri SURMERKANTIGEBLO
*	aŭ TAŬGECO POR IU KONKRETA CELO. Pliajn detalojn vidu en la GNUa
*	Ĝenerala Publika Permesilo.
*
*	Ekzemplero de la GNUa Ĝenerala Publika Permesilo devas esti liverita al vi
*	kun ĉi tiu programo; se vi ĝin ne ricevis, turnu vin al
*	
*	Free Software Foundation, Inc.,
*	59 Temple Place, Suite 330,
*	Boston, MA 02111-1307
*	USA
*
*/

# include "refal.h"
# include <sys/types.h>
# include <unistd.h>

void sis_sxargi (void) __attribute__ ((constructor));

void sis_system (void);
void sis_exit (void);
void sis_getpid (void);
void sis_getppid (void);


/* ========================================================================== */


extern void ref_eraro (int);
extern void interp_aldoni_enkonstruitan (char* nomo, void (*funk) (void));
extern void baz_krei_linion (char*);


/* ========================================================================== */

void sis_sxargi () {
	
	interp_aldoni_enkonstruitan ("system", sis_system);
	interp_aldoni_enkonstruitan ("exit", sis_exit);
	interp_aldoni_enkonstruitan ("getpid", sis_getpid);
	interp_aldoni_enkonstruitan ("getppid", sis_getppid);
	return;
}

/* ========================================================================== */


void sis_system () {
	int n;
	char *linio;
	LITERO *kuranta, *sekva, *antauxa;
	
	linio = (char *) malloc (sizeof (char) * LIN_LIM);
	if (linio == NULL) ref_eraro (1);
	baz_krei_linion (linio);
	n = system (linio);
	free (linio);
	krei_literon (antauxa);
	krei_literon (kuranta);
	krei_literon (sekva);
	ligi_literojn (KKK, antauxa);
	ligi_literojn (antauxa, kuranta);
	ligi_literojn (kuranta, sekva);
	kuranta->tip = CIFER;
	kuranta->dat.cif = (n == -1) ? 0 : 1;
	antauxa->tip = MD_LIT_PARENT;
	sekva->tip = D_LIT_PARENT;
	ligi_parentezojn (antauxa, sekva);
	krei_literon (antauxa);
	ligi_literojn (sekva, antauxa);
	krei_literon (kuranta);
	krei_literon (sekva);
	ligi_literojn (antauxa, kuranta);
	ligi_literojn (kuranta, sekva);
	ligi_literojn (sekva, KKP);
	kuranta->tip = CIFER;
	kuranta->dat.cif = (n == -1) ? 0 : (unsigned int) n;
	antauxa->tip = MD_LIT_PARENT;
	sekva->tip = D_LIT_PARENT;
	ligi_parentezojn (antauxa, sekva);
	return;
}


void sis_exit () {
	int n;
	LITERO *kuranta;
	
	if (!ESTAS_MD_LIT_PARENT (KKK->sekv)) ref_eraro (8);
	if ((KKK->sekv)->dat.dual != ((KKK->sekv)->sekv)->sekv) ref_eraro (8);
	kuranta = (KKK->sekv)->sekv;
	n = (int) (kuranta->dat.cif);
	ligi_literojn (KKK, (kuranta->sekv)->sekv);
	detrui_literon (kuranta->sekv);
	detrui_literon (kuranta->ant);
	detrui_literon (kuranta);
	if (KKK->sekv != KKP) ref_eraro (8);
	exit (n);
	return;
}


void sis_getpid () {
	LITERO *kuranta;
	
	if (KKK->sekv != KKP) ref_eraro (8);
	krei_literon (KKK->sekv);
	(KKK->sekv)->tip = MD_LIT_PARENT;
	(KKK->sekv)->ant = KKK;
	krei_literon (KKP->ant);
	(KKP->ant)->tip = D_LIT_PARENT;
	(KKP->ant)->sekv = KKP;
	ligi_parentezojn (KKK->sekv, KKP->ant);
	krei_literon (kuranta);
	kuranta->tip = CIFER;
	kuranta->dat.cif = (unsigned int) getpid ();
	ligi_literojn (KKK->sekv, kuranta);
	ligi_literojn (kuranta, KKP->ant);
	return;
}


void sis_getppid () {
	LITERO *kuranta;
	
	if (KKK->sekv != KKP) ref_eraro (8);
	krei_literon (KKK->sekv);
	(KKK->sekv)->tip = MD_LIT_PARENT;
	(KKK->sekv)->ant = KKK;
	krei_literon (KKP->ant);
	(KKP->ant)->tip = D_LIT_PARENT;
	(KKP->ant)->sekv = KKP;
	ligi_parentezojn (KKK->sekv, KKP->ant);
	krei_literon (kuranta);
	kuranta->tip = CIFER;
	kuranta->dat.cif = (unsigned int) getppid ();
	ligi_literojn (KKK->sekv, kuranta);
	ligi_literojn (kuranta, KKP->ant);
	return;
}



