/*
*	interpretilo2.c - iloj por aldono enkonstruitajn funkciojn.
*	© 2005, A.A.Vladimirov.
*
*	Ĉi tiu verko estas libera programaro; vi povas ĝin pludistribui kaj/aŭ
*	modifi je la kondiĉoj de la GNUa Ĝenerala Publika Permesilo, eldonita de
*	«Free Software Foundation», laŭ la versio 2 de tiu Permesilo aŭ, se vi
*	preferas, ajna posta versio.
*
*	Ni distribuas ĉi tiun programon esperante ke ĝi estos utila, tamen
*	SEN IA AJN GARANTIO, i.a. sen la implica garantio pri SURMERKANTIGEBLO
*	aŭ TAŬGECO POR IU KONKRETA CELO. Pliajn detalojn vidu en la GNUa
*	Ĝenerala Publika Permesilo.
*
*	Ekzemplero de la GNUa Ĝenerala Publika Permesilo devas esti liverita al vi
*	kun ĉi tiu programo; se vi ĝin ne ricevis, turnu vin al
*	
*	Free Software Foundation, Inc.,
*	59 Temple Place, Suite 330,
*	Boston, MA 02111-1307
*	USA
*
*/

# include "refal.h"


void interp_aldoni_enkonstruitan (char *nomo, void (*funk) (void));


/* ========================================================================== */


extern void ref_eraro (int);
extern unsigned long *interp_preni_nomon (char*, int*);
extern int interp_kompari_nomojn (unsigned long*, unsigned long*);


/* ========================================================================== */


/*
*	Funkcio "interp_aldoni_enkonstruitan" determinas enkonstruitan funkcion,
*	priskribatan en "funk".
*
*/

void interp_aldoni_enkonstruitan (char *nomo, void (*funk) (void)) {
	int i = 0;
	unsigned long *nomo1;
	FUNKCIO *f;
	
	nomo1 = interp_preni_nomon (nomo, &i);
	f = LF;
	do {
		f = f->sekv;
		i = interp_kompari_nomojn (nomo1, f->nom);
	} while (!i && (f->sekv != NULL));
	if (i) {
		f->enk = 1;
		free (nomo1);
		f->dat.f = funk;
	}
	else {
		f->sekv = (FUNKCIO *) malloc (sizeof (FUNKCIO));
		if (f->sekv == NULL) ref_eraro (1);
		f = f->sekv;
		f->enk = 1;
		f->nom = nomo1;
		f->dat.f = funk;
		f->sekv = NULL;
	};
	return;
}


