/*
*	masxino.c - ĝeneralaj funkcioj de la refalmaŝino.
*	© 2005, A.A.Vladimirov.
*
*	Ĉi tiu verko estas libera programaro; vi povas ĝin pludistribui kaj/aŭ
*	modifi je la kondiĉoj de la GNUa Ĝenerala Publika Permesilo, eldonita de
*	«Free Software Foundation», laŭ la versio 2 de tiu Permesilo aŭ, se vi
*	preferas, ajna posta versio.
*
*	Ni distribuas ĉi tiun programon esperante ke ĝi estos utila, tamen
*	SEN IA AJN GARANTIO, i.a. sen la implica garantio pri SURMERKANTIGEBLO
*	aŭ TAŬGECO POR IU KONKRETA CELO. Pliajn detalojn vidu en la GNUa
*	Ĝenerala Publika Permesilo.
*
*	Ekzemplero de la GNUa Ĝenerala Publika Permesilo devas esti liverita al vi
*	kun ĉi tiu programo; se vi ĝin ne ricevis, turnu vin al
*	
*	Free Software Foundation, Inc.,
*	59 Temple Place, Suite 330,
*	Boston, MA 02111-1307
*	USA
*
*/

# include "refal.h"
# include <libintl.h>


void ref_lancxi (void);
void ref_cxesigi (void);
void ref_eraro (int);


void ref_forfroti (void);
int ref_konkretigi (void);


/* ========================================================================== */


extern int ref_alfronti (void);
extern void ref_substitui (void);


/* ========================================================================== */


void ref_lancxi () {
	int i;
	
	do {
		KKP = LKP->dat.dual;
		KKK = KKP->dat.dual;
		LKP = LKP->sekv;
		detrui_literon (LKP->ant);
		i = ref_konkretigi ();
		ref_forfroti ();
	} while (i);
	return;
}


void ref_cxesigi () {
	
	return;
}


void ref_eraro (int ern) {
	
	switch (ern) {
		case 1:
			fprintf (stderr, "\n%s: %s.\n", gettext ("Eraro"),
			gettext ("eraro dum prenado memoron"));
			break;
		
		case 2:
			fprintf (stderr, "\n%s: %s.\n", gettext ("Eraro"),
			gettext ("malbona sekvenco de bajtoj"));
			break;

		case 3:
			fprintf (stderr, "\n%s: %s.\n", gettext ("Eraro"),
			gettext ("alfrontado estas neebla"));
			break;

		case 5:
			fprintf (stderr, "\n%s: %s.\n", gettext ("Eraro"),
			gettext ("tro longa linio"));
			break;

		case 6:
			fprintf (stderr, "\n%s: %s.\n", gettext ("Eraro"),
			gettext ("apliko je sendeterminita funkcio"));
			break;
			
		case 7:
			fprintf (stderr, "\n%s: %s.\n", gettext ("Eraro"),
			gettext ("malbona sekvenco de UTF-8"));
			break;

		case 8:
			fprintf (stderr, "\n%s: %s.\n", gettext ("Eraro"),
			gettext ("apliko je enkonstruita funkcio estas neebla"));
			break;

		default:
			fprintf (stderr, "\n%s: %s.\n", gettext ("Eraro"),
			gettext ("nerekonita eraro"));
			break;
	}
	exit (0);
	return;
}


/* ========================================================================== */


void ref_forfroti () {

	if (KKK->sekv == KKP) {	
		ligi_literojn (KKK->ant, KKP->sekv);
	}
	else {
		ligi_literojn (KKK->ant, KKK->sekv);
		ligi_literojn (KKP->ant, KKP->sekv);
	};
	detrui_literon (KKP);
	detrui_literon (KKK);
	return;
}


int ref_konkretigi () {
	int i, j = 1;
	
	if ((KKK->dat.funk)->enk) {
		(*((KKK->dat.funk)->dat.f)) ();
	}
	else {
		KFS = (KKK->dat.funk)->dat.s;
		if (KFS == NULL) ref_eraro (6);
		while (j) {
			i = ref_alfronti ();
			if (i) {
				ref_substitui ();
				j = 0;
			}
			else {
				if (KFS->sekv == NULL) ref_eraro (3);
				KFS = KFS->sekv;
			};
		};
	};
	if (KKK->dat.funk == LF) {
		return 0;
	}
	else {
		return 1;
	};
}

