/*
*	masxino1.c - detaligo je la refalmaŝino.
*	© 2005, A.A.Vladimirov.
*
*	Ĉi tiu verko estas libera programaro; vi povas ĝin pludistribui kaj/aŭ
*	modifi je la kondiĉoj de la GNUa Ĝenerala Publika Permesilo, eldonita de
*	«Free Software Foundation», laŭ la versio 2 de tiu Permesilo aŭ, se vi
*	preferas, ajna posta versio.
*
*	Ni distribuas ĉi tiun programon esperante ke ĝi estos utila, tamen
*	SEN IA AJN GARANTIO, i.a. sen la implica garantio pri SURMERKANTIGEBLO
*	aŭ TAŬGECO POR IU KONKRETA CELO. Pliajn detalojn vidu en la GNUa
*	Ĝenerala Publika Permesilo.
*
*	Ekzemplero de la GNUa Ĝenerala Publika Permesilo devas esti liverita al vi
*	kun ĉi tiu programo; se vi ĝin ne ricevis, turnu vin al
*	
*	Free Software Foundation, Inc.,
*	59 Temple Place, Suite 330,
*	Boston, MA 02111-1307
*	USA
*
*/

# include "refal.h"


LITERO* al [2];

int ref_alfronti (void);
void ref_substitui (void);


int ref_retirigxi (void);
int ref_kompari (VARIABLO*);
LITERO *ref_kopii (LITERO*, LITERO*, LITERO*);
void ref_stringi (void);
void ref_klarigi (void);


/* ========================================================================== */

extern void ref_eraro (int);


/* ========================================================================== */


/*
*	Funkcio "ref_alfronti" alfrontas refalesprimon inter KKK kaj KKP kun
*	refalesprimon inter KFS->mod kaj (KFS->mod)->dat.dual.
*	
*	Se alfrontado estas ebla, valoro de la funkcio estos 1. Okaze de tio,
*	valoroj "ant" kaj "sekv" de variabloj el alfrontita modelo estos
*	valoroj de la plej maldekstra varianto de alfrontado.
*
*	Se alfrontado estas neebla, valoro de la funkcio estos 0.
*	
*/

int ref_alfronti () {
	LITERO *kuranta;
	VARIABLO *v;
	int i;
	
	al [0] = KKK->sekv;
	al [1] = (KFS->mod)->sekv;
	while (1) {
		switch ((al [1])->tip) {
			case CIFER:
				if (ESTAS_CIFER (al [0])) {
					if ((al [0])->dat.cif == (al [1])->dat.cif) {
						al [0] = (al [0])->sekv;
						al [1] = (al [1])->sekv;
					}
					else {
						i = ref_retirigxi ();
						if (!i) return 0;
					};
				}
				else {
					i = ref_retirigxi ();
					if (!i) return 0;
				};
				break;
				
			case MD_LIT_PARENT:
			case D_LIT_PARENT:
			case MD_STR_PARENT:
			case D_STR_PARENT:
				if ((al [0])->tip == (al [1])->tip) {
					al [0] = (al [0])->sekv;
					al [1] = (al [1])->sekv;
				}
				else {
					i = ref_retirigxi ();
					if (!i) return 0;
				};
				break;
				
			case KONK_P:
				if (al [0] == KKP) {
					return 1;
				}
				else {
					i = ref_retirigxi ();
					if (!i) return 0;
				};
				break;
				
			case VAR:
				v = (al [1])->dat.var;
				switch (v->tip) {
					case S_MALAGEM:
					case W_MALAGEM:
					case E_MALAGEM:
						v->ant = (al [0])->ant;
						i = ref_kompari (v->ref);
						if (i) {
							v->sekv = al [0];
						}
						else {
							i = ref_retirigxi ();
							if (!i) return 0;
						};
						break;
					
					case S_AGEM:
						if (ESTAS_MD_LIT_PARENT (al [0])) {
							v->ant = (al [0])->ant;
							v->sekv = ((al [0])->dat.dual)->sekv;
							al [0] = v->sekv;
							al [1] = (al [1])->sekv;
						}
						else {
							i = ref_retirigxi ();
							if (!i) return 0;
						};
						break;

					case W_AGEM:
						if (ESTAS_MD_LIT_PARENT (al [0]) ||
						ESTAS_MD_STR_PARENT (al [0])) {
							v->ant = (al [0])->ant;
							v->sekv = ((al [0])->dat.dual)->sekv;
							al [0] = v->sekv;
							al [1] = (al [1])->sekv;
						}
						else {
							i = ref_retirigxi ();
							if (!i) return 0;
						};
						break;

					case E_AGEM:
						v->ant = (al [0])->ant;
						v->sekv = al [0];
						al [1] = (al [1])->sekv;
						break;
					
					case E_DUONAGEM:
						v->ant = (al [0])->ant;
						kuranta = al [1];
						while ((!ESTAS_MD_STR_PARENT (kuranta)) &&
						(!ESTAS_KONK_K (kuranta))) {
							if (ESTAS_D_LIT_PARENT (kuranta) ||
							ESTAS_D_STR_PARENT (kuranta)) {
								kuranta = kuranta->dat.dual;
								al [0] = (al [0])->dat.dual;
							};
							if (ESTAS_VAR (kuranta)) {
								al [0] =
									((kuranta->dat.var)->ant)->sekv;
							};
							kuranta = kuranta->ant;
							al [0] = (al [0])->ant;
						};
						kuranta = kuranta->dat.dual;
						if (ESTAS_KONK_K (al [0])) {
							al [0] = KKP;
						}
						else {
							al [0] = (al [0])->dat.dual;
						};
						i = 1;
						while (i) {
							kuranta = kuranta->ant;
							al [0] = (al [0])->ant;
							if (ESTAS_D_LIT_PARENT (kuranta) ||
							ESTAS_D_STR_PARENT (kuranta)) {
								if (((al [0])->tip != kuranta->tip) ||
								(al [0] == v->ant)) {
									i = ref_retirigxi ();
									if (!i) return 0;
									i = 0;
								}
								else {
									kuranta = kuranta->dat.dual;
									al [0] = al [0]->dat.dual;
								};
							};
							if (ESTAS_VAR (kuranta)) {
								if (kuranta == al [1]) {
									v->sekv = (al [0])->sekv;
									al [0] = (al [0])->sekv;
									al [1] = (al [1])->sekv;
									i = 0;
								}
								else {
									if (((!ESTAS_D_LIT_PARENT (al [0]))
									&& (!ESTAS_D_STR_PARENT (al [0])))
									|| (al [0] == v->ant)) {
										i = ref_retirigxi ();
										if (!i) return 0;
										i = 0;
									}
									else {
										al [0] = (al [0])->dat.dual;
									};
								};
							};
						};
						break;
				};
				break;
		};
	};
	return 0;
}


/*
*	Funkcio "ref_substitui" ŝanĝas esprimon inter KKK kaj KKP al esprimo,
*	kiu estos la rezulto de substituo je variabloj el KFS->mod en
*	esprimo KFS->rez.
*
*	Listo LKP ankaŭ ŝanĝas: se KFS->rez entenas konkretigojn, oni aldonas
*	tiajn konkretigojn inter LKP kaj LKP->sekv.
*	
*	# Referencoj "ant" el literoj de KFS->rez ne estas efektive utiligablaj.
*	# Sekve, oni povas uzi ĝijn kiel bufroj. Tia utiligo efektive uzatas
*	# en la funkcio.
*
*/

void ref_substitui () {
	LITERO *bufro, *kuranta_esp, *kuranta_rez, *kuranta_lkp, *unua, *lasta;
	VARIABLO *v;

	ref_stringi ();
	krei_literon (bufro);
	ligi_literojn (bufro, KKK->sekv);
	bufro->ant = NULL;
	kuranta_esp = KKK;
	kuranta_rez = KFS->rez;
	kuranta_lkp = LKP;
	
	while (kuranta_rez != NULL) {
		switch (kuranta_rez->tip) {
			case CIFER:
				krei_literon (bufro);
				ligi_literojn (kuranta_esp, bufro);
				kuranta_esp = bufro;
				kuranta_esp->tip = CIFER;
				kuranta_esp->dat.cif = kuranta_rez->dat.cif;
				break;
			
			case MD_LIT_PARENT:
				krei_literon (bufro);
				ligi_literojn (kuranta_esp, bufro);
				kuranta_esp = bufro;
				kuranta_esp->tip = MD_LIT_PARENT;
				krei_literon (bufro);
				ligi_parentezojn (kuranta_esp, bufro);
				bufro->tip = D_LIT_PARENT;
				(kuranta_rez->dat.dual)->ant = bufro;
				break;
			
			case D_LIT_PARENT:
				ligi_literojn (kuranta_esp, kuranta_rez->ant);
				kuranta_esp = kuranta_esp->sekv;
				break;
			
			case MD_STR_PARENT:
				krei_literon (bufro);
				ligi_literojn (kuranta_esp, bufro);
				kuranta_esp = bufro;
				kuranta_esp->tip = MD_STR_PARENT;
				krei_literon (bufro);
				ligi_parentezojn (kuranta_esp, bufro);
				bufro->tip = D_STR_PARENT;
				(kuranta_rez->dat.dual)->ant = bufro;
				break;
			
			case D_STR_PARENT:
				ligi_literojn (kuranta_esp, kuranta_rez->ant);
				kuranta_esp = kuranta_esp->sekv;
				break;
			
			case KONK_K:
				krei_literon (bufro);
				ligi_literojn (kuranta_esp, bufro);
				kuranta_esp = bufro;
				kuranta_esp->tip = KONK_K;
				kuranta_esp->dat.funk = kuranta_rez->dat.funk;
				krei_literon (bufro);
				bufro->tip = KONK_P;
				bufro->dat.dual = kuranta_esp;
				kuranta_rez->ant = bufro;
				break;
			
			case KONK_P:
				ligi_literojn (kuranta_esp, (kuranta_rez->dat.dual)->ant);
				kuranta_esp = kuranta_esp->sekv;
				krei_literon (bufro);
				if (kuranta_lkp == LKP) {
					LKP = bufro;
				}
				else {
					ligi_literojn (kuranta_lkp->ant, bufro);
				};
				ligi_literojn (bufro, kuranta_lkp);
				bufro->dat.dual = kuranta_esp;
				break;
			
			case VAR:
				v = kuranta_rez->dat.var;
				if ((v->ref)->ant != NULL) {
					unua = (v->ref)->ant;
					lasta = (v->ref)->sekv;
					if (ESTAS_S_AGEM (v) || ESTAS_W_AGEM (v) ||
					ESTAS_E_AGEM (v)) {
						kuranta_esp = ref_kopii
							(unua, lasta, kuranta_esp);
					}
					else {
						ligi_literojn (unua->ant, lasta->sekv);
						ligi_literojn (kuranta_esp, unua);
						kuranta_esp = lasta;
					};
				};
				break;
			
			default:
				ref_eraro (-1);
				break;
		};
		kuranta_rez = kuranta_rez->sekv;
	};
	ref_klarigi ();
	ligi_literojn (kuranta_esp, KKP);
	return;
}


/* ========================================================================== */


/*
*	Funkcio "ref_retirigxi" faras retiradon al la plej proksima (de maldekstra
*	flanko) agema e-variablo, kies valoro povas esti plilongigita per unu
*	termo. Origina stato de retirado determinatas per valoro de "al [1]".
*	
*	Se retirado estas malsukcesa, do la valoro de funkcio estos 0. Alie,
*	ĝi estos 1 kaj:
*	
*	1) La plej proksima al origina punkto agema e-variablo estos
*	plilongigita;
*	2) Valoro de "al [1]" estos la unua litero post tia variablo;
*	3) Valoro de "al [0]" estos la unua litero post valoro de tia variablo.
*
*/

int ref_retirigxi () {
	VARIABLO *v;
	
	while (1) {
		al [1] = (al [1])->ant;
		switch ((al [1])->tip) {
			case KONK_K:
				return 0;
				break;
			
			case VAR:
				v = (al [1])->dat.var;
				if (ESTAS_E_AGEM (v) && (ESTAS_MD_LIT_PARENT (v->sekv) ||
				ESTAS_MD_STR_PARENT (v->sekv))) {
					v->sekv = ((v->sekv)->dat.dual)->sekv;
					al [0] = v->sekv;
					al [1] = (al [1])->sekv;
					return 1;
				};
				break;
			
			default:
				break;
		};
	};
	return 0;
}


/*
*	Funkcio "ref_kompari" komparas komencon de la listo, sin originanta de
*	"al [0]", kun la valoro de variablo "v". Se oni ne havas kopion de
*	tia valoro en komenco de la listo, do valoro de la funkcio estos 0. Alie,
*	ĝi estos 1 kaj:
*	
*	1) Valoro de "al [1]" estos ŝanĝita al "(al [1])->sekv";
*	2) Valoro de "al [0]" estos la unua litero post kopio de valoro de
*	variablo "v".
*
*/

int ref_kompari (VARIABLO *v) {
	LITERO *vidata, *halto;
	
	vidata = (v->ant)->sekv;
	halto = v->sekv;
	while (1) {
		if (vidata == halto) {
			al [1] = (al [1])->sekv;
			return 1;
		};
		if ((al [0])->tip == vidata->tip) {
			if ((al [0])->tip == CIFER) {
				if ((al [0])->dat.cif != vidata->dat.cif) return 0;
			};
		}
		else {
			return 0;
		}
		vidata = vidata->sekv;
		al [0] = (al [0])->sekv;
	};
	return 0;
}


/*
*	Funkcio "ref_kopii" kopias sektoron de listo inter "unua" kaj "lasta"
*	(entenante tiajn du literojn), kaj gluas tian kopion post "espr".
*	
*	Valoro de funkcio estos referenco al la fino de 'gluata' listo.
*
*/

LITERO *ref_kopii (LITERO *unua, LITERO *lasta, LITERO *esp) {
	LITERO *sekva, *kuranta, *vidata;
	
	vidata = unua;
	kuranta = esp;
	while (1) {
		krei_literon (sekva);
		ligi_literojn (kuranta, sekva);
		kuranta = sekva;
		kuranta->tip = vidata->tip;
		switch (kuranta->tip) {
			case CIFER:
				kuranta->dat.cif = vidata->dat.cif;
				break;
			
			case MD_LIT_PARENT:
				vidata->dat.dual = kuranta;
				break;
			
			case D_LIT_PARENT:
				ligi_parentezojn ((vidata->dat.dual)->dat.dual, kuranta);
				(vidata->dat.dual)->dat.dual = vidata;
				break;
			
			case MD_STR_PARENT:
				vidata->dat.dual = kuranta;
				break;
			
			case D_STR_PARENT:
				ligi_parentezojn ((vidata->dat.dual)->dat.dual, kuranta);
				(vidata->dat.dual)->dat.dual = vidata;
				break;
		};
		if (vidata == lasta) {
			return kuranta;
		}
		else {
			vidata = vidata->sekv;
		};
	};
	return kuranta;
}


/*
*	Funkcio ref_stringi movas referencojn "(x->dat.var)->ant" kaj
*	"(x->dat.var)->sekv" por ĉiuj variabloj el "KFS->mod" internen de
*	la valoro de variabloj. Se ia e-variablo "x" havas malplena valoro,
*	do la nova valoro de "(x->dat.var)->ant" estos "NULL".
*
*	# EKZEMPLO: Konsideru modelon
*	#
*	#		KONK_K s/1/ ( e/2/ ) e/3/ KONK_P,
*	#
*	# alfrontitan kun esprimo
*	#
*	#		KONK_K a ( ) b c d KONK_P
*	#		1      2 3 4 5 6 7 8.
*	#
*	# Originaj valoroj estas:
*	#
*	# (s/1/->dat.var)->ant = 1,	(s/1/->dat.var)->sekv = 3,
*	# (e/2/->dat.var)->ant = 3,	(e/2/->dat.var)->sekv = 4,
*	# (e/3/->dat.var)->ant = 4,	(e/3/->dat.var)->sekv = 8.
*	#
*	# Novaj valoroj estos:
*	# (s/1/->dat.var)->ant = 2,	(s/1/->dat.var)->sekv = 2,
*	# (e/2/->dat.var)->ant = NULL,
*	# (e/3/->dat.var)->ant = 5,	(e/3/->dat.var)->sekv = 7.
*
*/

void ref_stringi () {
	LITERO *kuranta;
	VARIABLO *v;
	
	kuranta = KFS->mod;
	while (!ESTAS_KONK_P (kuranta)) {
		if (ESTAS_VAR (kuranta)) {
			v = kuranta->dat.var;
			if ((v->ant)->sekv == v->sekv) {
				v->ant = NULL;
			}
			else {
				v->ant = (v->ant)->sekv;
				v->sekv = (v->sekv)->ant;
			};
		};
		kuranta = kuranta->sekv;
	};
	return;
}


/*
*	Funkcio "ref_klarigi" liberigas memoron el senutiligita (konstruante
*	novan esprimon) parto de origina esprimo.
*
*/

void ref_klarigi () {
	LITERO *kuranta;
	
	kuranta = KKP->ant;
	while (kuranta->ant != NULL) {
		detrui_literon (kuranta);
		kuranta = kuranta->ant;
	};
	detrui_literon (kuranta);
	return;
}


