/*
*	refal.c - funkcio "main" de la refalsistemo.
*	© 2005, A.A.Vladimirov.
*
*	Ĉi tiu verko estas libera programaro; vi povas ĝin pludistribui kaj/aŭ
*	modifi je la kondiĉoj de la GNUa Ĝenerala Publika Permesilo, eldonita de
*	«Free Software Foundation», laŭ la versio 2 de tiu Permesilo aŭ, se vi
*	preferas, ajna posta versio.
*
*	Ni distribuas ĉi tiun programon esperante ke ĝi estos utila, tamen
*	SEN IA AJN GARANTIO, i.a. sen la implica garantio pri SURMERKANTIGEBLO
*	aŭ TAŬGECO POR IU KONKRETA CELO. Pliajn detalojn vidu en la GNUa
*	Ĝenerala Publika Permesilo.
*
*	Ekzemplero de la GNUa Ĝenerala Publika Permesilo devas esti liverita al vi
*	kun ĉi tiu programo; se vi ĝin ne ricevis, turnu vin al
*	
*	Free Software Foundation, Inc.,
*	59 Temple Place, Suite 330,
*	Boston, MA 02111-1307
*	USA
*
*/

# include "refal.h"
# include <libintl.h>


int NOM_LIM = 32;	/* Maksimuma longo de nomo */
int LIN_LIM = 2048;	/* Maksimuma longo de linio */
int VAR_LIM = 64;	/* Maksimuma kvanto de variabloj en FS */


int ARGC;			/* Unua argumento de C-funkcio "main" */
char **ARGV;		/* Dua argumento de C-funkcio "main" */


LITERO *LLM;		/* Listo de libera memoro */
FUNKCIO *LF;		/* Listo de funkcioj */
LITERO *LKP;		/* Listo de konkretigantaj punktoj */
LITERO *KKK;		/* Kuranta konkretiganta "k" */
LITERO *KKP;		/* Kuranta konkretiganta "." */
SUBSTITUO *KFS;	/* Kuranta formulo de substituo */


/* ========================================================================== */


extern void ref_lancxi (void);
extern void ref_cxesigi (void);
extern void ref_eraro (int);
extern void interp_krei_masxinon (char*);


/* ========================================================================== */

/*
*	Funkcio "main" konstruas originan staton de refalmaŝino:
*	1) Oni kreas liston de funkcioj, kiu entenas du funkciojn:
*		a) funkcion, haltantan je maŝino (efektive, ĝi ne havas nomon; tamen
*		   ni nomos ĝin "$halt");
*		b) funkcion kun nomo "$start".
*	2) Oni kreas originan refalesprimon 
*		k/$halt/ k/$start/ . .
*		1        2         3 4
*	3) Oni kreas liston de konkretigoj, kiu entenas referencojn al
*	konkretigantaj punktoj 3 kaj 4 (rig. punkton 2). Post la referenco al
*	konkretiganta punkto 4 oni havas aldonatan elementon de listo,
*	kiu montras nenien (sed necesas por iaj funkcioj).
*
*/

int main (int argc, char *argv []) {
	LITERO *kkh, *kks, *kps, *kph;
	
	setlocale (LC_ALL, "");
	textdomain ("refal");
	ARGC = argc;
	ARGV = argv;
	LLM = (LITERO *) malloc (sizeof (LITERO));
	LF = (FUNKCIO *) malloc (sizeof (FUNKCIO));
	if ((LLM == NULL) || (LF == NULL)) ref_eraro (1);
	LF->enk = 1;
	LF->dat.f = ref_cxesigi;
	LF->sekv = (FUNKCIO *) malloc (sizeof (FUNKCIO));
	if (LF->sekv == NULL) ref_eraro (1);
	(LF->sekv)->nom = (unsigned long *) malloc
		(sizeof (unsigned long) * NOM_LIM);
	if ((LF->sekv)->nom == NULL) ref_eraro (1);
	(LF->sekv)->enk = 0;
	(LF->sekv)->dat.s = NULL;
	(LF->sekv)->nom [0] = 36;
	(LF->sekv)->nom [1] = 115;
	(LF->sekv)->nom [2] = 116;
	(LF->sekv)->nom [3] = 97;
	(LF->sekv)->nom [4] = 114;
	(LF->sekv)->nom [5] = 116;
	(LF->sekv)->nom [6] = 0;
	(LF->sekv)->sekv = NULL;
	krei_literon (kkh);
	krei_literon (kks);
	krei_literon (kps);
	krei_literon (kph);
	krei_literon (kkh->ant);
	krei_literon (kph->sekv);
	ligi_literojn (kkh, kks);
	ligi_literojn (kks, kps);
	ligi_literojn (kps, kph);
	kkh->tip = KONK_K;
	kkh->dat.funk = LF;
	kks->tip = KONK_K;
	kks->dat.funk = LF->sekv;
	kps->tip = KONK_P;
	kps->dat.dual = kks;
	kph->tip = KONK_P;
	kph->dat.dual = kkh;
	krei_literon (LKP);
	krei_literon (LKP->sekv);
	krei_literon ((LKP->sekv)->sekv);
	(LKP->sekv)->ant = LKP;
	((LKP->sekv)->sekv)->ant = LKP->sekv;
	LKP->dat.dual = kps;
	(LKP->sekv)->dat.dual = kph;
	interp_krei_masxinon (argv [1]);
	ref_lancxi ();
	return 0;
}

